import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "%WOVQPOOOkQPO'#C_OOQO'#C_'#C_Q!SQPOOOOQO'#Cb'#CbO!_QPO'#CfOOQO'#Ci'#CiOVQPO'#CkOOQO'#Cn'#CnO!vQPO'#CmOOQO'#Cf'#CfOOQO'#C^'#C^O!{QPO,58{OVQPO,58}OVQPO,59OOVQPO,59PO#QQPO,59TO#VQPO'#ClO#hQPO,59VOVQPO,59XOOQO1G.g1G.gOOQO1G.i1G.iO#mQPO1G.jO$RQPO1G.kOOQO1G.o1G.oOVQPO'#CpO$gQPO,59WOOQO1G.q1G.qO$oQPO1G.sO$tQPO,59[OOQO-E6n-E6nOOQO7+$_7+$_",
  stateData: "%Y~OgOS~OSPOZYO[TO^UOcWOmVO~Oh[OeRXiRXjRXkRXnRXoRX~Oi]Oj^Ok_O~Ol`OeYXiYXjYXkYXnYXoYX~OmcO~OSdO~O[hO~Oi]Oj^Ok_OniOo`X~OokO~Oi]OeWijWikWinWioWi~Oi]Oj^OeXikXinXioXi~OniOo`a~OooO~Oi]Oj^Ok_Ondaoda~OSc~",
  goto: "#UePPfyP!Sy!]!]!]yPP!fP!f!o!f!uP#OQROSaVcQe]Qf^Qg_Rmi_ZOV]^_ci_QOV]^_ci_SOV]^_ci_YOV]^_ciQbVRlc_XOV]^_ciQjaRnj",
  nodeNames: "⚠ Program Expression CellReference AlphaNumCellReference CellReferenceRange BinaryExpression Boolean Product Addition Scalar Number String MeasureReference MachineMeasureReference Parentheses Arguments FunctionCall FunctionIdentifier Identifier",
  maxTerm: 31,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*v~RlX^!ypq!yqr#nrs#yxy$}yz%Sz{%X{|%^|}%c}!O%^!O!P%h!P!Q%X!Q![%m![!]&W!^!_&]!_!`#n!`!a&]!c!}&e#T#o&e#o#p&{#y#z!y$f$g!y#BY#BZ!y$IS$I_!y$I|$JO!y$JT$JU!y$KV$KW!y&FU&FV!y~#OYg~X^!ypq!y#y#z!y$f$g!y#BY#BZ!y$IS$I_!y$I|$JO!y$JT$JU!y$KV$KW!y&FU&FV!y~#qP!_!`#t~#yOi~~#|TOr$]s#Q$]#R;'S$];'S;=`$w<%lO$]~$`UOr$]rs$rs#Q$]#R;'S$];'S;=`$w<%lO$]~$wO[~~$zP;=`<%l$]~%SOm~~%XOo~~%^Oj~~%cOk~~%hOn~~%mOl~~%rQZ~!O!P%x!Q![%m~%{P!Q![&O~&TPZ~!Q![&O~&]Oh~~&bPi~!_!`#t~&jRc~!Q![&s!c!}&e#T#o&e~&xPS~!Q![&s~'OP#o#p'R~'UP!o!p'X~'[P#X#Y'_~'bP#T#U'e~'hP#g#h'k~'nP#i#j'q~'tP#f#g'w~'zP#X#Y'}~(QP#p#q(T~(WPrs(Z~(^TOr(ms#Q(m#R;'S(m;'S;=`*p<%lO(m~(pUOr(mrs)Ss#Q(m#R;'S(m;'S;=`*p<%lO(m~)VP!O!P)Y~)]Prs)`~)cTOr)rs#Q)r#R;'S)r;'S;=`*j<%lO)r~)uUOr)rrs*Xs#Q)r#R;'S)r;'S;=`*j<%lO)r~*[P#q#r*_~*bP#q#r*e~*jO^~~*mP;=`<%l)r~*sP;=`<%l(m",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 191
});

const nobieSheetsLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                CellReference: tags.variableName,
                Number: tags.number,
                String: tags.string,
                Identifier: tags.variableName,
                Boolean: tags.bool,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nobieSheets() {
    return new LanguageSupport(nobieSheetsLanguage);
}

export { nobieSheets, nobieSheetsLanguage };
